package com.s3ai.corporate_app2.controllers

import com.s3ai.corporate_app2.User
import com.s3ai.corporate_app2.UserService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Controller
import org.springframework.ui.Model
import org.springframework.web.bind.annotation.*
import org.springframework.web.servlet.view.RedirectView
import java.util.*

@Controller
@RequestMapping("/users")
class UsersController {
    @Autowired
    lateinit var userService: UserService

    @GetMapping("/list")
    fun getUsersBrowsePage(model: Model): String? {
        model.addAttribute("users", userService.findAll())
        return "users/list"
    }

    @GetMapping("/edit")
    fun getUSerEditPage(@RequestParam(name = "id", required = false, defaultValue = "") id: String, model: Model): String? {
        val user: User?
        if (id.isEmpty()) {
            user = User()
            user.id = UUID.randomUUID()
            model.addAttribute("action", "Create")
        } else {
            user = userService.findById(UUID.fromString(id))
            model.addAttribute("action", "Edit")
        }
        model.addAttribute("user", user)
        return "users/edit"
    }

    @PostMapping("/update")
    fun updateCinema(@ModelAttribute user: User): RedirectView {
        userService.save(user)
        return RedirectView("/users/list")
    }
}