package com.s3ai.corporate_app2.controllers

import com.s3ai.corporate_app2.CinemaServices
import org.springframework.ui.Model
import java.util.*
import javax.servlet.http.HttpServletResponse

fun <T> deleteInstance(id: String, instanceName: String, jpaService: CinemaServices<T>, response: HttpServletResponse): String? {
    var responseString: String? = null
    try {
        val itemId = UUID.fromString(id)
        val user = jpaService.findById(itemId)
        if (null != user) jpaService.delete(user)
        else {
            response.status = HttpServletResponse.SC_NOT_FOUND
            responseString = "$instanceName was not Found"
        }
    } catch (e: IllegalArgumentException) {
        response.status = HttpServletResponse.SC_BAD_REQUEST
        responseString = e.localizedMessage
    }
    return responseString
}