package com.s3ai.corporate_app2.controllers.rest;

import com.s3ai.corporate_app2.CinemaService
import com.s3ai.corporate_app2.Ticket
import com.s3ai.corporate_app2.TicketService
import com.s3ai.corporate_app2.UserService
import com.s3ai.corporate_app2.controllers.deleteInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/tickets")
class TicketApiController {
    @Autowired
    lateinit var userService: UserService
    @Autowired
    lateinit var ticketService: TicketService
    @Autowired
    lateinit var cinemaService: CinemaService

    @GetMapping("/fill")
    fun fillTickets(): String? {
        val wordsFirst = arrayOf("Pirates", "Ladies", "Goblins", "Gangsters", "Programmers", "Hackers", "Wrestlers", "Animals", "Guardians")
        val wordsSecond = arrayOf("of the", "in", "from")
        val wordsThird = arrayOf("Galaxy", "America", "Russia", "Japan", "Ocean", "Deep", "Caribbean", "Matrix", "Internet", "Woods", "Caves")

        val users = userService.findAll()
        val cinemas = cinemaService.findAll()

        val generatedNames: MutableList<String> = mutableListOf()
        for (i in 0..300) {
            val ticket = Ticket();
            ticket.id = UUID.randomUUID();
            ticket.movie = "${wordsFirst.random()} ${wordsSecond.random()} ${wordsThird.random()}";
            generatedNames.add(ticket.movie.toString())
            ticket.user = users.random()
            ticket.cinema = cinemas.random()
            ticketService.save(ticket);
        }
        return generatedNames.toString()
    }

    @DeleteMapping("/delete")
    fun deleteUser(@RequestParam(name = "id", required = true) id: String, response: HttpServletResponse): String? {
        return deleteInstance(id, "Ticket", ticketService, response)
    }

}
